"""This package provides all the functionality for automata

The goals of this package are to provide:
    * Transformations grammar <-> machine on all Chomsky hierarchy levels
    * Simulation capabilities to use the machines and understand how they accept
        the words generated by the corresponding grammar.

.. note:
    There is no submodule for "linear bounded automata", however the implemented
    transformation grammar -> Turing machine guarantees that the created machine
    does not expand the input tape if all productions are non-contracting.
    The transformation LBA -> grammar only guarantees a monotone
    grammar if the automaton never steps out of bounds of the initial input.

"""